<?php
  ///////////////////////////////////////////////////
  // Система учёта посещаемости сайта - PowerCounter
  // 2003-2006 (C) IT-студия SoftTime (http://www.softtime.ru)
  // Поддержка: http://www.softtime.ru/forum/
  // Симдянов И.В. (simdyanov@softtime.ru)
  // Левин А.В. (loki_angel@mail.ru)
  // Кузнецов М.В. (kuznetsov@softtime.ru)
  // Голышев С.В. (softtime@softtime.ru)
  ///////////////////////////////////////////////////
  // Выставляем уровень обработки ошибок (http://www.softtime.ru/info/articlephp.php?id_article=23)
  Error_Reporting(E_ALL & ~E_NOTICE); 

// Функция архивации точек входа в суточные таблицы
function archive_enterpoints($tbl_ip, $tbl_pages, $tbl_arch_enterpoint)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data FROM $tbl_ip");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);
  //Последнее полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate)) FROM $tbl_arch_enterpoint";
  $arh = mysql_query($query);
  if (!$arh) exit("enterpoint_date ".mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_ip 
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }
  //блок архивации
  if (ceil(($last_day - $last_date)/24/60/60))
  {
    $enterpoint_number = ENTERPOINT_NUMBER;

    $days = ceil(($last_day-$last_date)/24/60/60);
    for ($i = $days; $i > 0; $i--)
    {
      // Вспомогательное условие
      $tmp = "putdate < '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY AND
              putdate >= '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL $i DAY";

      // Извлекаем $id_number самых активных IP-адресов за сутки
      $query_enterpoint = "SELECT ip, min(putdate) AS putdate FROM $tbl_ip 
                           WHERE ".$tmp." AND browsers != 'none' AND systems != 'none'
                           GROUP BY ip";
      $tbp = mysql_query($query_enterpoint);
      if(!$tbp) exit("enterpoint - ".mysql_error());
      while($enterpoint = mysql_fetch_array($tbp))
      {
        $query = "SELECT $tbl_pages.name AS name 
                  FROM $tbl_ip, $tbl_pages 
                  WHERE $tbl_ip.ip = '".$enterpoint['ip']."' AND
                        $tbl_ip.putdate = '".$enterpoint['putdate']."' AND
                        $tbl_ip.id_page = $tbl_pages.id_page
                  GROUP BY name";
        $tpg = mysql_query($query);
        if(!$tpg) exit($query.mysql_error());
        if(mysql_num_rows($tpg) > 0) $page[] = mysql_result($tpg,0);
      }
      if(empty($page)) continue;
      $count_array = array_count_values($page);
      arsort($count_array);
      $j = 0;
      foreach($count_array as $pag => $tot)
      {
         if($j >= $enterpoint_number) break;
         $sql[] = "(NULL,
                    '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY,
                    '$pag',
                    $tot)";
         $j++;
      }
      unset($count_array, $page);
    }
    if(!empty($sql))
    {
      $query = "INSERT INTO $tbl_arch_enterpoint VALUES".implode(",", $sql);
      if(!mysql_query($query)) exit("enterpoint_day ".mysql_error());
    }
  }
}


// Функция архивации точек входа в недельные таблицы
function archive_enterpoints_week($tbl_arch_enterpoint, $tbl_arch_enterpoint_week)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data
                      FROM $tbl_arch_enterpoint");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate_end)) 
            FROM $tbl_arch_enterpoint_week";
  $arh = mysql_query($query);
  if(!$arh) exit(mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_arch_enterpoint
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // Вычисляем сколько недель прошло с даты последней архивации
  $week = floor(($last_day - $last_date)/24/60/60/7); 

  // Если прошло больше недели - архивируем данные
  if ($week > 0)
  {
    // $last_date - дата последней архивации... - смотрим далеко ли до
    // конца недели (воскресенье). Интервал включает данные с Понедельника (1)
    // до воскресенья (0).
    $weekday = date('w',$last_date);
    // Делаем так, чтобы воскресенье было 7, а понедельник 1
    // if($weekday === 0) $weekday = 7;

    $enterpoint_number = ENTERPOINT_NUMBER;

    // Текущему времени приравниваем начальную точку
    $current_date = $last_date;
    while(floor(($last_day - $current_date)/24/60/60/7))
    {
      // Вспомогательное условие
      $tmp = "putdate >= '".date("Y-m-d 23:59:59", $current_date)."' AND
              putdate < '" .date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."'";

      // Извлекаем $enterpoint_number самых активных точек входа
      $query_tbl_enterpoints = "SELECT page AS name, SUM(total) AS total 
                             FROM $tbl_arch_enterpoint 
                             WHERE ".$tmp." 
                             GROUP BY name 
                             ORDER BY total DESC 
                             LIMIT $enterpoint_number";

      $ref = mysql_query($query_tbl_enterpoints);
      if(!$ref) exit(mysql_error());

      // Формируем запрос для ахивации рефереров в таблицу $tbl_arch_enterpoints_week
      while($enterpoints = mysql_fetch_array($ref))
      {
        $sql_enterpoints[] = "(NULL,
                            '".date("Y-m-d 23:59:59", $current_date)."',
                            '".date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."',
                            '$enterpoints[name]',
                            $enterpoints[total])";
      }

      // Увеличиваем текущее время до следующей недели
      $current_date += (7 - $weekday)*24*3600;
      $weekday = 0; // Далее идут циклы по целой недели
      // echo date("Y-m-d 23:59:59", $current_date)."<br>";
    }

    // Формируем окончательный запрос и выполняем его
    if(!empty($sql_enterpoints))
    {
      $query = "INSERT INTO $tbl_arch_enterpoint_week VALUES".implode(",", $sql_enterpoints);
      if(!mysql_query($query)) exit(mysql_error());
    }
  }
}


// Функция архивации точек входа в месячные таблицы
function archive_enterpoints_month($tbl_arch_enterpoint, $tbl_arch_enterpoint_month)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data
                      FROM $tbl_arch_enterpoint");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate + INTERVAL 1 MONTH)) 
            FROM $tbl_arch_enterpoint_month";
  $arh = mysql_query($query);
  if(!$arh) exit(mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_arch_enterpoint
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y")) + 2;
  // Вычисляем сколько полных месяцев прошло с даты последней архивации
  $month = (floor(date("Y",$last_day) - date("Y",$last_date)))*12 + 
           floor(date("m",$last_day) - date("m",$last_date)); 

  // Если прошло больше месяца - архивируем данные
  if ($month > 0)
  {
    $enterpoint_number = ENTERPOINT_NUMBER;

    // Архивируем данные по всем месяцам, по которым архивация
    // не проводилась
    for($i = date("Y",$last_date)*12 + date("m",$last_date); $i < date("Y",$last_day)*12 + date("m",$last_day); $i++)
    {
      $year = (int)($i/12);
      $month = ($i%12);
      if($month == 0)
      {
        $year--;
        $month = 12;
      }
      // Вспомогательное условие
      $tmp = "YEAR(putdate) = $year AND
              MONTH(putdate) = '".sprintf("%02d",$month)."'";

      // Извлекаем $enterpoint_number самых активных точек входа
      $query_tbl_refferer = "SELECT page AS name, SUM(total) AS total 
                             FROM $tbl_arch_enterpoint 
                             WHERE ".$tmp." 
                             GROUP BY name 
                             ORDER BY total DESC 
                             LIMIT $enterpoint_number";

      $ref = mysql_query($query_tbl_refferer);
      if(!$ref) exit(mysql_error()."-".$query);

      // Формируем запрос для ахивации рефереров в таблицу $tbl_arch_refferer_month
      while($enterpoints = mysql_fetch_array($ref))
      {
        $sql_enterpoints[] = "(NULL,
                             '$year-".sprintf("%02d",$month)."-01 23:59:59',
                             '$enterpoints[name]',
                             $enterpoints[total])";
      }
    }

    // Формируем окончательный запрос и выполняем его
    if(!empty($sql_enterpoints))
    {
      $query = "INSERT INTO $tbl_arch_enterpoint_month VALUES".implode(",", $sql_enterpoints);
      if(!mysql_query($query)) exit(mysql_error()."-".$query);
    }
  }
}
?>